# ogCore project

## Descripción

ogCore es el servicio central de OpenGnsys, diseñado para proporcionar funcionalidades a través de una API RESTful. Esta herramienta utiliza tecnología PHP, aprovechando el framework Symfony y el ORM Doctrine para gestionar la base de datos.
A continuación, se detallan los pasos necesarios para desplegar el proyecto en un entorno de desarrollo.

## Requisitos

Antes de comenzar, asegúrate de tener los siguientes requisitos:

- Docker
- Docker compose

## Instalación

### Desplegar contenedores

Para que no haya conflictos entre los puertos, asegúrate de que no tienes ningún servicio corriendo en los puertos 8080 y 3306.

```sh
docker compose up --build -d
```

Comprobamos que se han levantado correctamente bien los 3 contenedores de la aplicación:

```sh
docker ps
```

Y deberiamos ver algo parecido a :

- ogcore-nginx
- ogcore-php
- ogcore-database


### Instalamos dependencias

```sh
docker exec ogcore-php composer install
docker exec ogcore-php symfony console lexik:jwt:generate-keypair --overwrite
```

Comprobamos, que el contenedor de Nginx, tiene el puerto 8080 levantado correctamente, asi que tan solo tendremos que
acceder a la siguiente URL:

```sh
http://127.0.0.1:8080/api/docs
```
Si todo ha ido bien, deberiamos ver la documentación de la API de ogCore.

Para poder actualizar la base de datos:

Para inicializar la base de datos:

```sh
docker exec ogcore-php symfony console doctrine:migrations:migrate --no-interaction
```

```sh
docker exec ogcore-php symfony console doctrine:fixtures:load --no-interaction
```
